function totable(t, match)
if not match then match = "[^%s]+" end
local cmd = {}
for word in string.gmatch(t,match) do
table.insert(cmd,word)
end
return cmd
end
function int(a,b)
local array = {}
for i = 1, a do
array[i] = b
end
return array
end
parse("mp_damagefactor 0")
parse("sv_fow 0")
parse("sv_maxplayers 4")
parse("mp_freezetime 6")
parse("sv_map bv_o_badminton1")
parse("mp_autoteambalance 1")
bm={}
bm.func={}
bm.hook={}
bm.server={}
bm.player={}
bm.server.x=0
bm.server.y=0
bm.botstart=false
bm.scoret=0
bm.scorect=0
addhook("startround","bm.hook.start")
function bm.hook.start(m)
	if m==1 then
		bm.server.x=256
		bm.server.y=320
		bm.server.win=0
		bm.server.dir=0
		bm.server.fly=false
		bm.server.str=0
	elseif m==2 then
		bm.server.x=256
		bm.server.y=224
		bm.server.win=0
		bm.server.dir=180
		bm.server.fly=false
		bm.server.str=0
	else
		local rand=math.random(1,2)
		if rand==2 then
			bm.server.x=256
			bm.server.y=320
			bm.server.win=0
			bm.server.dir=0
			bm.server.fly=false
			bm.server.str=0
		else
			bm.server.x=256
			bm.server.y=224
			bm.server.win=0
			bm.server.dir=180
			bm.server.fly=false
			bm.server.str=0
		end
	end
	bm.image=image("gfx/bv_badminton/1.png",bm.server.x,bm.server.y,1)
	function bm.bs()
		bm.botstart=true
	end
	bm.botstart=false
	timer(6500,"bm.bs")
end
addhook("always","bm.hook.alw")
function bm.hook.alw()
	if bm.server.fly then
		local tx,ty=math.floor(bm.server.x/32),math.floor(bm.server.y/32)
		if tile(tx,ty,"wall") then 
			bm.server.fly=false
			bm.server.str=0
			if bm.server.y<=48 then
				bm.server.win=2
				bm.scorect=bm.scorect+1
				msg("CT wins! CT score is "..bm.scorect)
				for ts=1,32 do if player(ts,"exists") and player(ts,"team")==1 then
					parse("killplayer "..ts)
				end end
			elseif bm.server.y>=496 then
				bm.server.win=1
				bm.scoret=bm.scoret+1
				msg("T wins! T score is "..bm.scoret)
				for cts=1,32 do if player(cts,"exists") and player(cts,"team")==2 then
					parse("killplayer "..cts)
				end end
			else
				local rand=math.random(1,2)
				if rand==2 then
					bm.server.x=256
					bm.server.y=320
					bm.server.win=0
					bm.server.dir=0
					bm.server.fly=false
					bm.server.str=0
					freeimage(bm.image)
					bm.image=image("gfx/bv_badminton/1.png",bm.server.x,bm.server.y,1)
				else
					bm.server.x=256
					bm.server.y=224
					bm.server.win=0
					bm.server.dir=180
					bm.server.fly=false
					bm.server.str=0
					freeimage(bm.image)
					bm.image=image("gfx/bv_badminton/1.png",bm.server.x,bm.server.y,1)
				end
			end
		else
			if bm.server.str>0 then
				local inrad=math.rad(bm.server.dir-180)
				local s,c= bm.server.x-math.sin(inrad)*math.floor(bm.server.str/100),bm.server.y+math.cos(inrad)*math.floor(bm.server.str/100)
				imagepos(bm.image,s,c,bm.server.dir)
				bm.server.str=bm.server.str-15
				bm.server.x=s
				bm.server.y=c
				if bm.server.str>500 then
					imagescale(bm.image,(bm.server.str/500),(bm.server.str/500))
				end
				if bm.server.str>=1000 then
					parse('effect "fire" '..bm.server.x+math.sin(inrad)..' '..bm.server.y-math.cos(inrad)..' 4 1')
				end
			end
		end
	end
	for bot=1,32 do
		if player(bot,"exists") and player(bot,"bot") then
			local a = -math.deg(math.atan2(player(bot,"x")-bm.server.x,player(bot,"y")-bm.server.y))
			if bm.botstart then
				if bm.server.str>0 then
					if player(bot,"y")<184 or player(bot,"y")>352 then
						ai_move(bot,a+math.random(-45,45))
					else
						if a<0 then
							ai_move(bot,-90) else
							ai_move(bot,90)
						end
						ai_move(bot,0)
						ai_move(bot,180)
						if bm.server.fly then
							if player(bot,"y")<256 and player(bot,"y")>184 then
								ai_move(bot,0)
							elseif player(bot,"y")<352 and player(bot,"y")>288 then
								ai_move(bot,180)
							end
						end
					end
				else
					ai_move(bot,a)
				end
				local inx,iny=player(bot,"x"),player(bot,"y")
				parse("setpos "..bot.." "..player(bot,"x")+(1).." "..player(bot,"y")+(1))
				parse("setpos "..bot.." "..inx.." "..iny)
			end
			ai_attack(bot)
		end
	end
end
addhook("attack","bm.hook.attack")
function bm.hook.attack(id)
	local dist= math.sqrt((bm.server.x-player(id,"x"))^2 + (bm.server.y-player(id,"y"))^2)
	if dist < 40 then
		local a = player(id,"rot")
		if a<0 then a=a+360 end
		a=a+math.random(-5,5)
		bm.server.fly=true
		if player(id,"bot") then
			bm.server.dir=a+math.random(-15,15) else bm.server.dir=a
		end
		bm.server.str=math.floor(bm.server.str/100)+750
	end
end
addhook("attack2","bm.hook.attack2")
function bm.hook.attack2(id)
	local dist= math.sqrt((bm.server.x-player(id,"x"))^2 + (bm.server.y-player(id,"y"))^2)
	if dist < 34 then
		local a = player(id,"rot")
		if a<0 then a=a+360 end
		a=a+math.random(-15,15)
		bm.server.fly=true
		bm.server.dir=a
		bm.server.str=math.floor(bm.server.str/100)+1500
		parse('effect "smoke" '..player(id,'x')..' '..player(id,'y')..' 64 32')
	end
end
addhook("spawn","bm.hook.spawn")
function bm.hook.spawn(id)
	if player(id,"bot") then
		parse("speedmod "..id.." 5")
	else parse("speedmod "..id.." 12") end
end
addhook("move", "collisionThink")
function collisionThink(ply, x, y)
	for _, ply2 in pairs(player(0, "table")) do
		if (ply ~= ply2 and player(ply2, "health") > 0) then
			local x2, y2 = player(ply2, "x"), player(ply2, "y")
			local d = math.sqrt((x2-x)^2 + (y2-y)^2) -- Calculate distance between the two players
			if (d < 30) then
				local a = -(math.atan2(x2-x,y2-y)+math.pi/2)%(2*math.pi) -- Calculate angle between two players and convert it from the CS2D unit circle (from 0 on the Y plane and 90 on the X clockwise to 0 on the X plane and 90 on the Y anticlockwise)
				local nx, ny = x2 + math.cos(a)*30, y2 + math.sin(a)*30 -- Calculate position as 30 pixels away from the centre of the second player along the angle calculated above
				if (tile(math.floor(nx/32), math.floor(ny/32), "walkable")) then
					parse("setpos " .. ply .. " " .. nx .. " " .. ny)
				end
			end
		end
	end
end